#ifndef ARRAY_BACKUP_H
#define ARRAY_BACKUP_H

#include "primtypes.h"
#include "key_val.h"

#define AB_MINIMUM_STACK 4
#define AB_STACK_MUL  1.41421356237
#define AB_STACK_ADD  3

typedef enum { AB_STACK=0 } ab_strat_t;

typedef struct ab_struct {
  ab_strat_t strategy;
  array_index_t stack_top;
  size_t stack_size;
  key_val_p stack;
  struct ab_struct *next;
} array_backup_t, *array_backup_p, *ab_p, ab_t;

array_backup_p ab_new(int size);
void ab_destroy(array_backup_p back);
void ab_restore8(array_backup_p back, int8_t *array);
void ab_restore16(array_backup_p back, int16_t *array);
void ab_restore32(array_backup_p back, int32_t *array);
void ab_set(array_backup_p back, int key, int val);
int ab_capacity(ab_p bck);
int ab_fill(ab_p bck);
void ab_report(ab_p b);
#endif
