#include <stdlib.h>
#include <stdio.h>
#include "int_dict_stack.h"
#include "int_dict.h"



ids_p ids_new(int dictsize){
  ids_p new;

  new=memalloc(sizeof(ids_t));

  new->top=NULL;
  new->dictsize=dictsize;
  ids_push(new);
  return new;
}

void ids_destroy(ids_p stack){

  while(stack->top){
    ids_pop(stack);
  }
  free(stack);
}

void ids_push(ids_p stack){
  int_dict_p new=id_new(stack->dictsize);

  new->next=stack->top;
  stack->top=new;
}

void ids_pop(ids_p stack){
    int_dict_p dead=stack->top;
    stack->top=stack->top->next;
    id_destroy(dead);
}  

void ids_set(ids_p stack,int key,int val,bool overwrite){
  id_set(stack->top,key,val,overwrite);
}

void ids_map(ids_p stack,id_hook func,void *arg){
  id_map(stack->top,func,arg);
}


void ids_report(ids_p stack){
  int_dict_p cur;
  int fill=0,cap=0,count=0;
  for (cur=stack->top; cur; cur=cur->next){
    fill+=id_filled(cur);
    cap+=id_capacity(cur);
    count++;
    id_report(cur);
  }
  fprintf(stderr,"total(%d) %d/%d =%03f\n",count,fill,cap, cap ? (double)fill/cap : 0);
}
