#ifndef NU_SIGN_SET_H
#define NU_SIGN_SET_H
#include "oms_types.h"
#include "nu_sign.h"
#include "nu_signed_index.h"
#include "int_queue.h"



typedef struct nu_sign_set_struct {
  natural_t size;
  int_queue_p queue;
  bool *present;
  nu_sign_p sign;
} nu_sign_set_t, *nu_sign_set_p;

/* nu_sign_set.c */
nu_sign_set_p nss_new(natural_t ssize);
void nss_dump(nu_sign_set_p ss);
void nss_fixup(na_node_p node, slot_t slot); /*NA_FUNC*/
na_node_p nss_nalloc(na_node_p node, slot_t slot, natural_t ssize);
void nss_destroy(nu_sign_set_p S);
bool nss_add(nu_sign_set_p S, int k, nu_sign_t sign);
int nss_empty(nu_sign_set_p S);
int nss_count(nu_sign_set_p S);
nu_signed_index_t nss_deq(nu_sign_set_p S);
array_index_t nss_deq_index(nu_sign_set_p S);
nu_signed_index_t nss_next(nu_sign_set_p S);

#define nss_next_index(S) nsi_index(nss_next(S))
#endif
