#ifndef _RIDGE_GRAPH_H
#define _RIDGE_GRAPH_H

#include "oms_types.h"
#include "statearray.h"
#include "be_struct.h"

typedef struct rg_struct {
  natural_t dim; /**< dimension of ridge graph, i.e. 
		    how many vertices on each    facet */
  natural_t elements; /**< how many vertices in total */
  natural_t bases;
  array_index_t source; /**< facet long path starts at */
  array_index_t sink; /**< facet long path ends at */
  natural_t diameter; /**< how far they are apart */
  sa_array_p source_dist; /**< distance from source facet in ridge_graph*/
  sa_array_p sink_dist; /**< distance from sink facet in ridge_graph */
}  ridge_graph_t,*ridge_graph_p;


typedef  ridge_graph_p ridge_graph;

#include "bindex_table.h"

#define RG_INFINITY NATURAL_T_MAX


extern na_node_p rg_nalloc(na_node_p, slot_t, natural_t, natural_t,
			   array_index_t, array_index_t, natural_t);

extern bool rg_add_facet(ridge_graph, array_index_t, sarray_p, be_block_p);
extern void rg_dump(ridge_graph);
extern void rg_restore(ridge_graph);
extern void rg_save(ridge_graph);
extern void rg_fixup(na_node_p,slot_t);/*NA_FUNC*/
#endif
  
