/* vc_lb.h

   Vertex cover lower bounds

   Ambros Marzetta

   94-10-14
   For more information see our WWW page at
   
         http://wwwjn.inf.ethz.ch/ambros/zram.html
	 
 * $Source$
 * $Revision: 2732 $
 * $Date: 2000-11-15 12:14:52 -0400 (Wed, 15 Nov 2000) $
 * $Log$
 * Revision 1.2  2000/11/15 16:14:52  bremner
 * committing patched version of zram source
 *
 * Revision 1.1  1998/04/15  08:47:29  marzetta
 * Initial revision
 *
 *
 */

#include "vc_base.h"

/* Lower Bounds:
   1: edges / maxdegree (useless)
   2: some matching
   3: triangles
   4: cliques
   5: two subgraphs with constant lower bound
   6: two subgraphs: solve these (very slow)
   7: maximum matching
   */

MINT vc_LowerBound(vc_GlobalP global, vc_NodeP np);
/* Choose one of the other procedures. */

void PrintLbHisto(char * name, int solution);
/* Print the histogram of lower bounds. */

